// You can import API functions like this from D3.js.
import { select, 
        csv,
        scaleLinear,
        max, 
        scaleBand,
        axisLeft,
        axisBottom,
        format
       } from 'd3';
const svg= select('svg');

const width= +svg.attr('width');
const height= +svg.attr('height');

const render = data => {
  const xValue =d =>d.qtde;
  const yValue= d=> d.Codigo;
  const margin= {top: 50, right:20, bottom:70, left:100};
  const innerWidth = width - margin.left - margin.right;
  const innerHeight = height - margin.top - margin.bottom;
  
  const xScale = scaleLinear()
    .domain([0,max(data, xValue)])
    .range([0,innerWidth]);
  
  const yScale = scaleBand()
    .domain(data.map(yValue))
    .range([0,innerHeight])
    .padding(0.1);

  const g = svg.append('g')
    .attr('transform', `translate(${margin.left},${margin.top})`);
 
  const xAxis= axisBottom(xScale)
   .tickFormat(format('.3s'));
  
  g.append('g').call(axisLeft(yScale))
   .selectAll('.domain, .tick line')
   .remove();
  
 const xAxisG =  g.append('g').call(xAxis)
    .attr('transform', `translate(0,${innerHeight})`)
 xAxisG.selectAll('.domain, .tick line').remove(); 
 
 xAxisG.append('text')
    .attr('class', 'axis-label')
    .attr('y', 60)
    .attr('x', innerWidth/2)
    .attr('fill', 'black')
    .text('Volume');
  
  g.selectAll('rect').data(data)
    .enter().append('rect')
       .attr('y', d => yScale(yValue(d)))
       .attr('width', d => xScale(xValue(d)))
       .attr('height', yScale.bandwidth());

  g.append('text')
    .attr('y', -10)
    .text('Top 20 maiores volumes de negociação da b3');
};
csv('data.csv').then(data=>{
  data.forEach(d=> {
    d.qtde= parseFloat(d.qtde) * 1000;
  });  
  render(data);
});